<template>
  <div id="navbar">
    <b-navbar
      v-b-color-mode="'dark'"
      toggleable="md"
      variant="dark"
      :sticky="'top'"
    >
      <!-- Coscine Logo -->
      <b-navbar-brand id="coscineLogo">
        <!-- Added conditional navigation to avoid navigation guard errors in the console -->
        <RouterLink v-if="isLoggedIn" :to="{ name: 'home' }">
          <img
            alt="Coscine Logo"
            src="@/assets/svg/coscine_white.svg"
            class="mx-3"
          />
        </RouterLink>
        <b-link v-else :href="$t('nav.url.coscine').toString()">
          <img
            alt="Coscine Logo"
            src="@/assets/svg/coscine_white.svg"
            class="mx-3"
          />
        </b-link>
      </b-navbar-brand>

      <b-navbar-toggle target="nav-collapse" class="b-0" />
      <b-collapse id="nav-collapse" is-nav>
        <!-- Search Bar -->
        <b-navbar-nav v-if="searchBarVisibility" class="ms-auto px-2">
          <b-nav-form
            v-b-color-mode="currentTheme"
            @submit.stop.prevent="triggerSearch"
          >
            <b-input-group size="sm" class="searchBar">
              <template #prepend>
                <b-button
                  :disabled="!searchTerm"
                  variant="light"
                  @click="triggerSearch"
                >
                  <i-bi-search />
                </b-button>
              </template>
              <b-form-input
                id="search"
                v-model="searchTerm"
                type="search"
                :placeholder="$t('nav.search')"
              />
            </b-input-group>
          </b-nav-form>
        </b-navbar-nav>

        <!-- Right aligned nav items -->
        <b-navbar-nav class="ms-auto">
          <b-nav-item-dropdown right>
            <template #button-content>
              <i-bi-circle-half class="toggle-theme" />
              <span class="d-lg-none ms-2">{{ $t("nav.theme.toggle") }}</span>
            </template>
            <b-dropdown-item-button
              data-bs-theme-value="light"
              @click="setMode('light')"
              ><i-bi-sun-fill class="me-2 opacity-50 theme-icon" />
              {{ $t("nav.theme.light") }}
              <i-bi-check2 class="ms-auto d-none"
            /></b-dropdown-item-button>
            <b-dropdown-item-button
              data-bs-theme-value="dark"
              @click="setMode('dark')"
              ><i-bi-moon-stars-fill class="me-2 opacity-50 theme-icon" />
              {{ $t("nav.theme.dark") }}
              <i-bi-check2 class="ms-auto d-none"
            /></b-dropdown-item-button>
          </b-nav-item-dropdown>

          <b-nav-item-dropdown right>
            <template #button-content>
              <i-bi-globe2 />
              <span class="d-lg-none ms-2">{{ $t("nav.lang") }}</span>
            </template>
            <!-- Language Options -->
            <b-dropdown-item
              v-for="(locale, index) in locales"
              :key="index"
              :disabled="$i18n.locale === locale"
              @click="changeLocale(locale)"
            >
              {{ $t("nav.lang" + locale.toUpperCase()) }}
            </b-dropdown-item>
          </b-nav-item-dropdown>

          <!-- Disclaimer -->
          <b-nav-item
            :href="$t('nav.url.privacyPolicy').toString()"
            target="_blank"
          >
            {{ $t("nav.privacyPolicy") }}
          </b-nav-item>

          <!-- Imprint -->
          <b-nav-item
            :href="$t('nav.url.extrasImprint').toString()"
            target="_blank"
          >
            {{ $t("nav.extrasImprint") }}
          </b-nav-item>

          <b-nav-item-dropdown v-if="isLoggedIn" text="?" right>
            <!-- Help -->
            <b-dropdown-item
              :href="$t('nav.url.extrasHelp').toString()"
              target="_blank"
            >
              {{ $t("nav.extrasHelp") }}
            </b-dropdown-item>
            <!-- Accessibility -->
            <b-dropdown-item
              :href="$t('nav.url.extrasAccessibility').toString()"
              target="_blank"
            >
              {{ $t("nav.extrasAccessibility") }}
            </b-dropdown-item>
            <!-- Contact -->
            <b-dropdown-item :href="'mailto:' + contactEmail" target="_blank">
              {{ $t("nav.extrasContact") }}
            </b-dropdown-item>
          </b-nav-item-dropdown>

          <b-nav-item-dropdown v-if="isLoggedIn" right>
            <template v-if="user" #button-content>
              {{
                $t("nav.user", {
                  displayName: user
                    ? user.displayName
                    : $t("default.none").toString(),
                })
              }}
            </template>
            <template v-else #button-content>
              <b-placeholder
                animation="wave"
                height="1.5rem"
                width="10rem"
                style="display: inline-flex; margin-bottom: 0rem"
              />
            </template>
            <!-- UserProfile -->
            <b-dropdown-item :to="{ name: 'userprofile' }">
              {{ $t("nav.userProfile") }}
            </b-dropdown-item>
            <!-- Divider -->
            <b-dropdown-divider />
            <!-- Log out -->
            <b-dropdown-item @click="logUserOut">
              {{ $t("nav.userLogOut") }}
            </b-dropdown-item>
          </b-nav-item-dropdown>

          <router-link
            v-else
            v-slot="{ href, isActive }"
            :to="{ name: 'login' }"
            custom
          >
            <b-nav-item
              v-if="isLoggedIn"
              right
              :disabled="isActive"
              :href="href"
            >
              {{ $t("nav.userLogIn") }}
            </b-nav-item>
          </router-link>
        </b-navbar-nav>
      </b-collapse>
    </b-navbar>
  </div>
</template>

<script lang="ts">
// import the main store
import useMainStore from "@/store/index";
// import the login store
import useLoginStore from "@/modules/login/store";
// import the user store
import useUserStore from "@/modules/user/store";
import type { UserDto } from "@coscine/api-client/dist/types/Coscine.Api";
import type { Theme } from "@/store/types";

export default defineComponent({
  setup() {
    const mainStore = useMainStore();
    const loginStore = useLoginStore();
    const userStore = useUserStore();

    return { mainStore, loginStore, userStore };
  },
  data() {
    return {
      searchTerm: "",
    };
  },
  computed: {
    contactEmail(): string {
      return this.userStore.contactEmail;
    },
    currentTheme(): Theme {
      return this.mainStore.currentTheme;
    },
    locales(): Array<string> {
      return this.$i18n.availableLocales;
    },
    isLoggedIn(): boolean {
      return this.loginStore.isLoggedIn;
    },
    searchBarVisibility(): boolean {
      if (this.isLoggedIn && this.$route.name !== "search") {
        return true;
      }
      return false;
    },
    user(): UserDto | null | undefined {
      return this.userStore.user;
    },
  },
  mounted() {
    // From: https://getbootstrap.com/docs/5.3/customize/color-modes/#javascript
    const storedTheme = this.currentTheme;

    this.setTheme(this.getPreferredTheme(storedTheme));

    window.addEventListener("DOMContentLoaded", () => {
      this.showActiveTheme(this.getPreferredTheme(storedTheme));
    });
  },
  methods: {
    changeLocale(locale: string): void {
      this.mainStore.coscine.locale = locale;
    },
    logUserOut() {
      this.loginStore.logout();
    },
    triggerSearch() {
      // If searchTerm is not empty
      if (this.searchTerm) {
        // attach search query, resulting in "/search?q=<searchTerm>"
        this.$router.push({ name: "search", query: { q: this.searchTerm } });
      }
    },
    toggleSidebar() {
      this.mainStore.sidebarActive = !this.mainStore.sidebarActive;
    },
    getPreferredTheme(storedTheme: Theme | null) {
      if (storedTheme) {
        return storedTheme;
      }

      return window.matchMedia("(prefers-color-scheme: dark)").matches
        ? "dark"
        : "light";
    },
    setMode(theme: Theme | null) {
      if (theme !== null) {
        this.mainStore.setTheme(theme);
        this.setTheme(theme);
        this.showActiveTheme(theme);
      }
    },
    setTheme(theme: Theme) {
      document.documentElement.dataset.bsTheme = theme;
    },
    showActiveTheme(theme: Theme) {
      const activeThemeIcon = document.querySelector(".theme-icon-active use");
      const buttonToActive = document.querySelector(
        `[data-bs-theme-value="${theme}"]`,
      );
      if (buttonToActive !== null && activeThemeIcon !== null) {
        const svgQuery = buttonToActive.querySelector("svg use");
        if (svgQuery !== null) {
          const svgOfActiveButton = svgQuery.getAttribute("href");

          if (svgOfActiveButton !== null) {
            for (const element of document.querySelectorAll(
              "[data-bs-theme-value]",
            )) {
              element.classList.remove("active");
            }

            buttonToActive.classList.add("active");
            activeThemeIcon.setAttribute("href", svgOfActiveButton);
          }
        }
      }
    },
  },
});
</script>

<style scoped>
#navbar .navbar {
  padding-top: 0;
  padding-bottom: 0;
}
#navbar :deep(.unplugin-icon-coscine) {
  width: 1.2em;
  height: 1.2em;
}
.navbar-nav .nav-item {
  padding-right: 0.5rem;
  padding-left: 0.5rem;
}
#coscineLogo {
  border: 0px;
  object-fit: cover;
  object-position: 0%;
  width: 60px;
  min-width: 60px;
}
.searchBar {
  min-width: var(--search-bar-width);
}
#navbar :deep(#search::-webkit-search-cancel-button) {
  color-scheme: v-bind(currentTheme);
}
</style>
